/*********************************************************
 *                   TUOX - knihovny                     *
 *********************************************************
 *            				                 *
 * Funkce:    fgets()                                    *
 *            fputs()                                    *
 *            				                 *
 * Detaily:   stdio.htm                                  *
 *            				                 *
 * Autori:    Daniel Smolka & Eva Drstakova     (c) 1999 *
 *                                                       *
 *********************************************************/

 #include "lib\stdio\ffs.h"


char* fgets (char *s, int n, FILE *stream)
{
 int readlen;

#ifdef _NULLSTREAM_TEST
 if (!stream) return NULL;	/* no stream */
#endif

 readlen = read (stream->fd, s, n);
 
 if (readlen == EOF)
  { 
   stream->flags |= _F_ERR;	/* error */
   return NULL;
  }

 if (!readlen)
  { 
   stream->flags |= _F_EOF;	/* eof */
   return NULL;
  }

 *(s+n-1) = '\n';			/* podle definice */
 *(s+readlen-1+strlen("\n")) = 0x00;	/* podle definice */

 stream->flags &= !(_F_ERR|_F_EOF);	/* OK */
 return s;
}


int fputs(const char *s, FILE *stream)
{
 unsigned int len;
 int succ;

#ifdef _NULLSTREAM_TEST
 if (!stream) return EOF;	/* no stream */
#endif

 len = strlen (s);

 succ = write (stream->fd, s, len);

 if (succ == EOF || succ == 0)
  {
   stream->flags |= _F_ERR;	/* error */
   return EOF;
  }

 write (stream->fd, "\n", strlen("\n"));
 stream->flags &= !_F_ERR;	/* OK */
 return 0;
}
