/*********************************************************
 *                   TUOX - knihovny                     *
 *********************************************************
 * Funkce:    fread()                                    *
 *            fwrite()                                   *
 *            				                 *
 * Detaily:   stdio.html                                 *
 *            				                 *
 * Autori:    Daniel Smolka & Eva Drstakova     (c) 1999 *
 *                                                       *
 *********************************************************/

#include "lib\stdio\ffs.h"

size_t fread(void  *ptr, size_t size, size_t n, FILE  *stream) {
 size_t len;
 
#ifdef _NULLSTREAM_TEST
 if (!stream) return 0;		/* NULL handle */
#endif

 len = (size_t) read ((int)stream->fd, ptr, (unsigned int)(size*n));

 if (len == -1) {
  stream->flags |= _F_ERR;
  return 0;			/* error */
 }
 if (!len) {
  stream->flags |= _F_EOF;
  return 0;			/* eof */
 }

 stream->flags &= !(_F_ERR|_F_EOF);
 return len/size;		/* OK */
}



size_t fwrite(const void  *ptr, size_t size, size_t n, FILE  *stream) {
 size_t len;

#ifdef _NULLSTREAM_TEST
 if (!stream) return NULL;	/* NULL handle */
#endif

 len = (size_t) write ((int)stream->fd, ptr, (unsigned int)(size*n));

 if (len == EOF) {
  stream->flags |= _F_ERR;
  return 0;			/* error */
 }

 stream->flags &= !_F_ERR;
 return len/size;		/* OK */
}
