/*********************************************************
 *                   TUOX - knihovny                     *
 *********************************************************
 * Funkce:    strerror() - preklad cisla chyby na vyznam *
 *            perror() - vypis chyboveho hlaseni         *
 *            				                 *
 * Detaily:   stdio.html                                 *
 *            				                 *
 * Autori:    Daniel Smolka & Eva Drstakova     (c) 1999 *
 *                                                       *
 *********************************************************/

#include "lib\stdio\ffs.h"

char* strerror(int errnum)
{
 switch (errnum) {
	case (_SIGN  0):  return ("no error");
	case (_SIGN  1):  return ("operation not permitted");
	case (_SIGN  2):  return ("no such file or directory");
	case (_SIGN  3):  return ("no such process");
	case (_SIGN  4):  return ("interrupted function call");
	case (_SIGN  5):  return ("input/output error");
	case (_SIGN  6):  return ("no such device or address");
	case (_SIGN  7):  return ("arg list too long");
	case (_SIGN  8):  return ("exec format error");
	case (_SIGN  9):  return ("bad file descriptor");
	case (_SIGN 10):  return ("no child process");
	case (_SIGN 11):  return ("resource temporarily unavailable");
	case (_SIGN 12):  return ("not enough space");
	case (_SIGN 13):  return ("permission denied");
	case (_SIGN 14):  return ("bad address");
	case (_SIGN 15):  return ("Extension: not a block special file");
	case (_SIGN 16):  return ("resource busy");
	case (_SIGN 17):  return ("file exists");
	case (_SIGN 18):  return ("improper link");
	case (_SIGN 19):  return ("no such device");
	case (_SIGN 20):  return ("not a directory");
	case (_SIGN 21):  return ("is a directory");
	case (_SIGN 22):  return ("invalid argument");
	case (_SIGN 23):  return ("too many open files in system");
	case (_SIGN 24):  return ("too many open files");
	case (_SIGN 25):  return ("inappropriate I/O control operation");
	case (_SIGN 26):  return ("no longer used");
	case (_SIGN 27):  return ("file too large");
	case (_SIGN 28):  return ("no space left on device");
	case (_SIGN 29):  return ("invalid seek");
	case (_SIGN 30):  return ("read-only file system");
	case (_SIGN 31):  return ("too many links");
	case (_SIGN 32):  return ("broken pipe");
	case (_SIGN 33):  return ("domain error       (from ANSI C std)");
	case (_SIGN 34):  return ("result too large   (from ANSI C std)");
	case (_SIGN 99):  return ("generic error");
 }
 return ("unknown error");
}


void perror(const char *s)
{
 char *error = strerror(errno);

 if (s) {
  write (FD_STDERR, s, strlen(s));
  write (FD_STDERR, ": ", 2);
 }
 write (FD_STDERR, error, strlen(error));
 write (FD_STDERR, "\n", strlen("\n"));
}
