/*********************************************************
 * Soubor:    div.c                                      *
 * Popis:     Celociselne deleni se zbytkem		 *
 *            				                 *
 * Autor:     Martin Vojvodik, 1997                      *
 *							 *
 * Preprac:   Daniel Tvrdy, 1997			 *
 *********************************************************/

#include "LIB\stdlib.h"


/*--------------------------------------------------------------------------*

Name            div - integer division

Usage           div_t div(int numer, int denom);

Prototype in    stdlib.h

Description     div computes the quotient and  remainder of the division of
                the numerator  "numer" by the  denominator "denom". If  the
                result cannot be represented, the behavior is undefined.

Return value    div returns a structure of  type div_t, comprising both the
                quotient and the remainder.

/*--------------------------------------------------------------------------*/
div_t   div(int numer, int denom)
{
  div_t result;

  result.quot = numer/denom;
  result.rem = numer%denom;
  return result;
}

