/*********************************************************
 * Soubor:    ldiv.c                                     *
 * Popis:     Celociselne deleni se zbytkem typu long    *
 *            				                 *
 * Autor:     Martin Vojvodik, 1997                      *
 *							 *
 * Preprac:   Daniel Tvrdy, 1997			 *
 *********************************************************/

#include "LIB\stdlib.h"


/*-----------------------------------------------------------------------*

Name            ldiv - long integer division

Usage           ldiv_t ldiv(long numer, long denom);

Prototype in    stdlib.h

Description     ldiv computes  the quotient and remainder  of the ldivision
                of the numerator "numer" by the denominator "denom". If the
                result cannot be represented, the behavior is undefined.

Return value    ldiv returns  a structure of  type ldiv_t, comprising  both
                the quotient and the remainder.

*------------------------------------------------------------------------*/
ldiv_t  ldiv(long numer, long denom)
{
 ldiv_t  result;

 result.quot = numer/denom;
 result.rem = numer%denom;
 return result;
}
