/*********************************************************
 * Funkce:    srand.c                                    *
 * Popis:     Inicializace generatoru pseudonahodnych    *
 *	      cisel				         *
 *********************************************************
 * Funkce:    rand.c                                     *
 * Popis:     Vraci pseudonahodne cislo rozsahu 	 *
 *            0..MAX_RAND                                *
 *********************************************************
 *            				                 *
 * Autor:     Martin Vojvodik, 1997                      *
 *							 *
 * Preprac:   Daniel Tvrdy, 1997			 *
 *********************************************************/

#include "LIB\stdlib.h"

#define MULTIPLIER      1103515245L
#define INCREMENT       12345

static  long    Seed = 1;


/*---------------------------------------------------------------------*

Name            srand - initializes random number generator

Usage           void srand(unsigned seed);

Prototype in    stdlib.h

Description     see rand below

Return value    Nothing

*---------------------------------------------------------------------*/
void srand(unsigned seed)
{
        Seed = seed;
}


/*---------------------------------------------------------------------*

Name            rand - random number generator

Usage           int rand(void);

Related
functions usage void srand(unsigned seed);

Prototype in    stdlib.h

Description     rand uses a multiplicative congruential random number
                generator with period 2^32 to return successive pseudo-
                random numbers in the range from 0 to 2^15 - 1.

                The generator is reinitialized by calling srand with an
                argument value of 1. It can be set to a new starting point by
                calling srand with a given seed number.

*---------------------------------------------------------------------*/
int rand(void)
{
        Seed = MULTIPLIER * Seed + INCREMENT;
        return((int)(Seed >> 16) & 0x7fff);
}
